#include <iostream>
using namespace std;


struct Instrument {
  // Questa funzione e' polimorfica 
  // Virtuale PURA in questo caso: la classe diventa ASTRATTA
  virtual void play() = 0;
};

// si puo' usare come "helper" l'implementazione di una virtuale pura
// 
void Instrument::play() {
  cout << "!!?" << endl;
};

struct Piano : public Instrument {
  // sono costretto a fare OVERRIDING della funzione virtuale pura
  void play() { 
    //Instrument::play();  // helper function
    cout << "pling" << endl;
  }
};

// Il polimorfismo funziona solo con puntatori e referenze
void two_notes(Instrument & i) {
  i.play(); i.play();
}

int main() {
  //Piano p;
  //two_notes(p);
  //Instrument astrattofono;  // non posso perche' e' astratta
  
  Instrument * pi = new Piano;
  pi->play(); // polimorfismo!
}
